//
//  FWViewController.m
//  FrameWorks
//
//  Created by Ruedi Arnold on 22.04.13.
//  Copyright (c) 2013 Ruedi Arnold. All rights reserved.
//

#import "FWViewController.h"

#define ANNOTATION_TITLE_HSLU @"HSLU"


@implementation FWViewController

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    MKPointAnnotation* myAnnotation = [[MKPointAnnotation alloc] init];
    myAnnotation.coordinate = CLLocationCoordinate2DMake(47.014084, 8.305793);
    myAnnotation.title = ANNOTATION_TITLE_HSLU;
    myAnnotation.subtitle = @"Technik & Architektur";
    [self.mapView addAnnotation:myAnnotation];
    
    myAnnotation = [[MKPointAnnotation alloc] init];
    myAnnotation.coordinate = CLLocationCoordinate2DMake(47.017274, 8.306801);
    myAnnotation.title = @"Horw";
    myAnnotation.subtitle = @"Bahnhof zb";
    [self.mapView addAnnotation:myAnnotation];
    
    [self centerHSLUButtonPressed:nil];
}

- (void)viewDidUnload
{
    [self setFirstNameLabel:nil];
    [self setLastNameLabel:nil];
    [self setMapView:nil];
    [self centerHSLUButtonPressed:nil];
    [self setAppearanceCounterLabel:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark IBActions

- (IBAction)getPersonButtonPressed:(id)sender {
    
    ABAddressBookRef addressBook;
    if ([self isABAddressBookCreateWithOptionsAvailable])
    {
        addressBook = ABAddressBookCreateWithOptions(NULL, nil);
        ABAddressBookRequestAccessWithCompletion(addressBook, ^(bool granted, CFErrorRef error) {
            dispatch_async(dispatch_get_main_queue(), ^{
                if (error)
                {
                    // display error message here
                }
                else if (!granted)
                {
                    // display access denied error message here
                }
                else
                {
                    // access granted
                    // do the important stuff here
                }
            });
        });
    }

    
    ABPeoplePickerNavigationController* peoplePicker = [[ABPeoplePickerNavigationController alloc] init];
    peoplePicker.peoplePickerDelegate= self;
    [self presentViewController:peoplePicker animated:YES completion:nil];
}

- (BOOL)isABAddressBookCreateWithOptionsAvailable
{
    return &ABAddressBookCreateWithOptions != NULL;
}

- (IBAction)centerHSLUButtonPressed:(id)sender {
    [self.mapView setRegion:MKCoordinateRegionMake(CLLocationCoordinate2DMake(47.016, 8.306), MKCoordinateSpanMake(0.005, 0.005)) animated:YES];
}

- (IBAction)showEventButtonPressed:(id)sender {
    EKEventStore *store = [[EKEventStore alloc] init];

    
    // The next lines are from http://stackoverflow.com/questions/12754064/how-to-get-the-name-id-of-default-calendar-in-ios-6
    if ([store respondsToSelector:@selector(requestAccessToEntityType:completion:)])
    {
        /* iOS Settings > Privacy > Calendars > MY APP > ENABLE | DISABLE */
        [store requestAccessToEntityType:EKEntityTypeEvent completion:^(BOOL granted, NSError *error)
         {
             if ( granted )
             {
                 NSLog(@"User has granted permission!");
             }
             else
             {
                 NSLog(@"User has not granted permission!");
             }
         }];
    }
    
    
        // Code from http://developer.apple.com/library/ios/#documentation/DataManagement/Conceptual/EventKitProgGuide/FetchingEvents.html#//apple_ref/doc/uid/TP40004775-SW1
    
    //    CFGregorianDate gregorianStartDate, gregorianEndDate;
    //    CFGregorianUnits startUnits = {0, 0, 1, 0, 0, 0};
    //    CFGregorianUnits endUnits = {0, 0, 15, 0, 0, 0};
    //    CFTimeZoneRef timeZone = CFTimeZoneCopySystem();
    //    gregorianStartDate = CFAbsoluteTimeGetGregorianDate(CFAbsoluteTimeAddGregorianUnits(CFAbsoluteTimeGetCurrent(), timeZone, startUnits), timeZone);
    //    gregorianStartDate.hour = 0;
    //    gregorianStartDate.minute = 0;
    //    gregorianStartDate.second = 0;
    //
    //    gregorianEndDate = CFAbsoluteTimeGetGregorianDate(CFAbsoluteTimeAddGregorianUnits(CFAbsoluteTimeGetCurrent(), timeZone, endUnits), timeZone);
    //    gregorianEndDate.hour = 0;
    //    gregorianEndDate.minute = 0;
    //    gregorianEndDate.second = 0;
    //
    //    NSDate* startDate = [NSDate dateWithTimeIntervalSinceReferenceDate:CFGregorianDateGetAbsoluteTime(gregorianStartDate, timeZone)];
    //
    //    NSDate* endDate = [NSDate dateWithTimeIntervalSinceReferenceDate:CFGregorianDateGetAbsoluteTime(gregorianEndDate, timeZone)];
    //    CFRelease(timeZone);
    
    NSDate* startDate = [[NSDate alloc] init];
    NSDate* endDate   = [[NSDate alloc] initWithTimeInterval:60*60*24*365 sinceDate:startDate];
    
    
    NSPredicate *predicate = [store predicateForEventsWithStartDate:startDate endDate:endDate calendars:nil];
    NSArray *events = [store eventsMatchingPredicate:predicate];
    
    if ([events count] > 0) {
        EKEventEditViewController* eventViewController = [[EKEventEditViewController alloc] init];
        eventViewController.eventStore = store;
        eventViewController.event = [events objectAtIndex:0];
        eventViewController.editViewDelegate = self;
        [self presentViewController:eventViewController animated:YES completion:nil];
    }
}

#pragma mark EventKit

- (void)eventEditViewController:(EKEventEditViewController *)controller didCompleteWithAction:(EKEventEditViewAction)action {
    [self dismissViewControllerAnimated:YES completion:nil];
}

#pragma mark AddressBook

- (BOOL)peoplePickerNavigationController:(ABPeoplePickerNavigationController *)peoplePicker shouldContinueAfterSelectingPerson:(ABRecordRef)person {
    
    self.firstNameLabel.text = (__bridge_transfer NSString*)ABRecordCopyValue(person, kABPersonFirstNameProperty);
    self.lastNameLabel.text = (__bridge_transfer NSString*)ABRecordCopyValue(person, kABPersonLastNameProperty);
    
    [self dismissViewControllerAnimated:YES completion:nil];
    
    return NO;
}

- (BOOL)peoplePickerNavigationController:(ABPeoplePickerNavigationController *)peoplePicker shouldContinueAfterSelectingPerson:(ABRecordRef)person property:(ABPropertyID)property identifier:(ABMultiValueIdentifier)identifier {
    
    return NO;
}

- (void)peoplePickerNavigationControllerDidCancel:(ABPeoplePickerNavigationController *)peoplePicker {
    [self dismissViewControllerAnimated:YES completion:nil];
}

#pragma mark MapViewDelegate


- (void)mapView:(MKMapView *)mapView annotationView:(MKAnnotationView *)view calloutAccessoryControlTapped:(UIControl *)control {
    UIAlertView* alertView = [[UIAlertView alloc] initWithTitle:@"Information"
                                                        message:@"Cool, you pressed the i-Button"
                                                       delegate:nil
                                              cancelButtonTitle:@"No, wasn't me ;-)"
                                              otherButtonTitles:nil];
    [alertView show];
}

- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id <MKAnnotation>)annotation {
    if ([annotation.title isEqualToString:ANNOTATION_TITLE_HSLU]) {
        MKAnnotationView* annView = [[MKAnnotationView alloc] initWithAnnotation:annotation reuseIdentifier:ANNOTATION_TITLE_HSLU];
        annView.image = [UIImage imageNamed:@"icon.png"];
        annView.canShowCallout = YES;
        annView.rightCalloutAccessoryView = [UIButton buttonWithType:UIButtonTypeInfoLight];
        return annView;
    } else {
        MKPinAnnotationView* myAnnView = [[MKPinAnnotationView alloc] initWithAnnotation:annotation reuseIdentifier:@"whatever"];
        myAnnView.pinColor = MKPinAnnotationColorGreen;
        myAnnView.canShowCallout = YES;
        return myAnnView;
    }
}

@end
